'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handlers = undefined;

var _handlers;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = searchReducer;

var _constants = require('./constants');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * The user must add this reducer to their app store/tree.
 * By default it is assumed that this reducer will be added at :search.
 * If you use another location you must pass a custom :searchStateSelector to reduxSearch().
 */
function searchReducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var _ref = arguments[1];
  var payload = _ref.payload;
  var type = _ref.type;

  if (handlers.hasOwnProperty(type)) {
    return handlers[type](state, payload);
  } else {
    return state;
  }
}

/**
 * Search state reducers.
 */
var handlers = exports.handlers = (_handlers = {}, _defineProperty(_handlers, _constants.INITIALIZE_RESOURCES, function (state, _ref2) {
  var resourceNames = _ref2.resourceNames;

  return resourceNames.reduce(function (result, resourceName) {
    result[resourceName] = {
      isSearching: false,
      result: [],
      text: ''
    };
    return result;
  }, _extends({}, state));
}), _defineProperty(_handlers, _constants.RECEIVE_RESULT, function (state, _ref3) {
  var resourceName = _ref3.resourceName;
  var result = _ref3.result;

  return _extends({}, state, _defineProperty({}, resourceName, _extends({}, state[resourceName], {
    isSearching: false,
    result: result
  })));
}), _defineProperty(_handlers, _constants.SEARCH, function (state, _ref4) {
  var resourceName = _ref4.resourceName;
  var text = _ref4.text;

  return _extends({}, state, _defineProperty({}, resourceName, _extends({}, state[resourceName], {
    isSearching: true,
    text: text
  })));
}), _handlers);