'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = searchMiddleware;

var _constants = require('./constants');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 * Middleware for interacting with the search API
 * @param {Search} Search object
 */
function searchMiddleware(search) {
  return function (_ref) {
    var dispatch = _ref.dispatch;
    return function (next) {
      return function (action) {
        var payload = action.payload;

        if (action.type === _constants.SEARCH_API) {
          var method = payload.method;
          var args = payload.args;

          return search[method].apply(search, _toConsumableArray(args));
        } else if (action.type === _constants.ACTION) {
          next(payload.action);
          return dispatch(payload.api);
        } else {
          return next(action);
        }
      };
    };
  };
}