var _handlers;

import { INITIALIZE_RESOURCES, RECEIVE_RESULT, SEARCH } from './constants';

/**
 * The user must add this reducer to their app store/tree.
 * By default it is assumed that this reducer will be added at :search.
 * If you use another location you must pass a custom :searchStateSelector to reduxSearch().
 */
export default function searchReducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var _ref = arguments[1];
  var payload = _ref.payload;
  var type = _ref.type;

  if (handlers.hasOwnProperty(type)) {
    return handlers[type](state, payload);
  } else {
    return state;
  }
}

/**
 * Search state reducers.
 */
export var handlers = (_handlers = {}, babelHelpers.defineProperty(_handlers, INITIALIZE_RESOURCES, function (state, _ref2) {
  var resourceNames = _ref2.resourceNames;

  return resourceNames.reduce(function (result, resourceName) {
    result[resourceName] = {
      isSearching: false,
      result: [],
      text: ''
    };
    return result;
  }, babelHelpers.extends({}, state));
}), babelHelpers.defineProperty(_handlers, RECEIVE_RESULT, function (state, _ref3) {
  var resourceName = _ref3.resourceName;
  var result = _ref3.result;

  return babelHelpers.extends({}, state, babelHelpers.defineProperty({}, resourceName, babelHelpers.extends({}, state[resourceName], {
    isSearching: false,
    result: result
  })));
}), babelHelpers.defineProperty(_handlers, SEARCH, function (state, _ref4) {
  var resourceName = _ref4.resourceName;
  var text = _ref4.text;

  return babelHelpers.extends({}, state, babelHelpers.defineProperty({}, resourceName, babelHelpers.extends({}, state[resourceName], {
    isSearching: true,
    text: text
  })));
}), _handlers);